/*
 * Copyright 2009 Ben Axelrod
 * 
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the Creative Commons Attribution-Noncommercial-Share
 * Alike 3.0 United States License. 
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * To view a copy of this license, visit:
 * 
 * http://creativecommons.org/licenses/by-nc-sa/3.0/us/
 *
 * or send a letter to:
 * Creative Commons
 * 171 Second Street, Suite 300
 * San Francisco, California 94105 USA
 */


using System;
using System.Collections.Generic;


using Microsoft.Ccr.Core;
using Microsoft.Dss.ServiceModel.Dssp;
using Microsoft.Dss.Core.Attributes;
using dssp = Microsoft.Dss.ServiceModel.Dssp;

namespace Microsoft.Robotics.Services.SimpleDashboard
{

    /// <summary>
    /// DSS Contract for SimpleDashboard
    /// </summary>
    static class Contract
    {
        /// <summary>
        /// The DSS Namespace for SimpleDashboard
        /// </summary>
        public const string Identifier = "http://schemas.microsoft.com/robotics/2006/01/simpledashboard.html";
    }

    /// <summary>
    /// The SimpleDashboard Operations Port
    /// </summary>
    class SimpleDashboardOperations : PortSet<DsspDefaultLookup, DsspDefaultDrop, Get, Replace>
    {
    }

    /// <summary>
    /// DSS Get Definition for SimpleDashboard 
    /// </summary>
    class Get : Get<dssp.GetRequestType, PortSet<SimpleDashboardState, W3C.Soap.Fault>>
    {
        /// <summary>
        /// Default DSS Get Constructor
        /// </summary>
        public Get()
        {
        }

        /// <summary>
        /// DSS GetRequestType Constructor
        /// </summary>
        /// <param name="body"></param>
        public Get(dssp.GetRequestType body)
            : base(body)
        {
        }

    }

    /// <summary>
    /// DSS Replace Definition for SimpleDashboard 
    /// </summary>
    class Replace : Replace<SimpleDashboardState, PortSet<dssp.DefaultReplaceResponseType, W3C.Soap.Fault>>
    {
        /// <summary>
        /// Default DSS Get Constructor
        /// </summary>
        public Replace()
        {
        }

        /// <summary>
        /// DSS SimpleDashboard StateType Constructor
        /// </summary>
        /// <param name="body"></param>
        public Replace(SimpleDashboardState body)
            : base(body)
        {
        }       
    }

}
